{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit CGrMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, NewGrids, StdCtrls, ExtCtrls, Buttons, MultComb,
  Mask, RtReg, RtStdReg;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    MultiComboBox1: TMultiComboBox;
    MultiComboBox2: TMultiComboBox;
    MultiComboBox3: TMultiComboBox;
    MultiComboBox4: TMultiComboBox;
    MultiComboBox5: TMultiComboBox;
    MultiComboBox6: TMultiComboBox;
    MultiComboBox7: TMultiComboBox;
    Edit1: TEdit;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Image1: TImage;
    Memo1: TMemo;
    ColorStringGrid1: TColorStringGrid;
    RegStdPropertyEditors1: TRegStdPropertyEditors;
    procedure FormCreate(Sender: TObject);
    procedure ColorStringGrid1SelCellChange(Sender: TObject;
      ASelection: TGridRect);
    procedure ColorStringGrid1SelCellChanging(Sender: TObject;
      ASelection: TGridRect);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ColorStringGrid1GetCellProperties(Sender: TObject; ACol,
      ARow: Longint; AState: TGridDrawState; var AColor: TColor;
      var AText: OpenString; var TextAlignment: TAlignment;
      var TextColor: TColor);
    procedure ColorStringGrid1Sizing(Sender: TObject; ColSizing: Boolean;
      Index: Longint; Distance: Integer; var Accept: Boolean);
    procedure CheckBoxenClick(Sender: TObject);
    procedure ComboBoxenCloseUp(Sender: TObject);
    procedure ComboBoxenDblClick(Sender: TObject);
    procedure ComboBoxenExit(Sender: TObject);
    procedure ComboBoxenKeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    procedure GetSelPropIndex(Sender: TObject; var SelIndex: Integer);
    procedure InspectorChanged(Sender: TObject);
    procedure ShowPropValue(Sender: TObject);
    procedure UpdatePropValue(Control: TWinControl; AutoUpdate: Boolean);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  DsgnIntf, TypInfo, PropInfo, EventInf, DemoHelp, DemConst;

{ Demonstration einer einfachen Ableitung von TPropertyInspector }
type
  TGetSelPropertyEvent = procedure (Sender: TObject;
    var SelIndex: Integer) of object;

  TDemoPropertyInspector = class(TPropertyInspector)
  private
    FOnGetSelProperty: TGetSelPropertyEvent;
    FOnUpdateDisplayValue: TNotifyEvent;
  protected
    function GetSelProperty: Integer; override;
    procedure UpdateDisplayValues; override;
  public
    procedure RefreshDisplay; override;
  published
    property OnGetSelProperty: TGetSelPropertyEvent read FOnGetSelProperty write FOnGetSelProperty;
    property OnUpdateDisplayValue: TNotifyEvent read FOnUpdateDisplayValue write FOnUpdateDisplayValue;
  end;

var
  Inspector: TDemoPropertyInspector;

procedure TForm1.FormCreate(Sender: TObject);
var
  I, J: Integer;
begin
  InitHelp;
  with ColorStringGrid1 do
    for I := 0 to ColCount - 1 do
      for J := 0 to RowCount - 1 do
        Cells[I, J] := IntToStr(I) + '/' + IntToStr(J);

  Inspector := TDemoPropertyInspector.Create(self);
  with Inspector do
  begin
    PropertyFilter := tkAny;
    Form := self;
    OnChange := InspectorChanged;
    OnGetSelProperty := GetSelPropIndex;
    OnUpdateDisplayValue := ShowPropValue;
    ComponentList := MakeComponentList([ColorStringGrid1]);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeHelp;
end;

procedure TForm1.ColorStringGrid1SelCellChange(Sender: TObject;
  ASelection: TGridRect);
begin
  ShowEventInfo(Sender, 'ColorStringGrid1SelCellChange', SOnSelCellChangeParam,
    SOnSelCellChangeInfo, SPerCheckBox);
end;

procedure TForm1.ColorStringGrid1SelCellChanging(Sender: TObject;
  ASelection: TGridRect);
begin
  ShowEventInfo(Sender, 'ColorStringGrid1SelCellChanging', SOnSelCellChangingParam,
    SOnSelCellChangingInfo, SPerCheckBox);
end;

procedure TForm1.ColorStringGrid1Sizing(Sender: TObject;
  ColSizing: Boolean; Index: Longint; Distance: Integer;
  var Accept: Boolean);
begin
  ShowEventInfo(Sender, 'ColorStringGrid1Sizing', SOnSizingParam,
    SOnSizingInfo, SPerCheckBox);
end;

procedure TForm1.ColorStringGrid1GetCellProperties(Sender: TObject; ACol,
  ARow: Longint; AState: TGridDrawState; var AColor: TColor;
  var AText: OpenString; var TextAlignment: TAlignment;
  var TextColor: TColor);
begin
  with ColorStringGrid1 do
  begin
    AColor := RGB(ACol * 36, ARow * 36, 0);
    if (ACol < FixedCols) or (ARow < FixedRows) then TextAlignment := taCenter
    else if Odd(ARow) then TextAlignment := taRightJustify
    else TextColor := clWhite;
  end;
end;

{ Hilfe fr alle gezeigten Eigenschaften }
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F1) and (Shift = []) and (ActiveControl.Tag <> -1) then
    with ActiveControl, Inspector.PropertyList do
    begin
      ShowDemoHelp(PropName[Tag], TColorStringGrid, True,
        PropKind[Tag] = tkMethod, False);
      Key := 0;
    end;
end;

procedure TForm1.ComboBoxenCloseUp(Sender: TObject);
begin
  UpdatePropValue(TWinControl(Sender), False);
end;

procedure TForm1.ComboBoxenDblClick(Sender: TObject);
begin
  with TWinControl(Sender) do
    if Tag <> -1 then
    begin
      Inspector.PropertyList.EditProp(Tag);
      {$IFDEF WIN32}
         SendMessage(Handle, EM_SETSEL, 0, -1);
      {$ELSE}
         SendMessage(Handle, EM_SETSEL, 1, $FFFF0000);
      {$ENDIF}
    end;
end;

procedure TForm1.ComboBoxenExit(Sender: TObject);
begin
  UpdatePropValue(TWinControl(Sender), False);
end;

procedure TForm1.ComboBoxenKeyPress(Sender: TObject; var Key: Char);
begin
  if not TMultiComboBox(Sender).DroppedDown then
    UpdatePropValue(TWinControl(Sender), Key <> #13);
end;

procedure TForm1.Edit1Exit(Sender: TObject);
begin
  UpdatePropValue(TWinControl(Sender), False);
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  UpdatePropValue(TWinControl(Sender), Key <> #13);
end;

{ Setzen und Entfernen der Ereignisbehandlungsroutinen des ColorStringGrids }
procedure TForm1.CheckBoxenClick(Sender: TObject);
var
  EventHandler: TStrings;
begin
  with Sender as TCheckBox do
    if Focused and (Tag <> -1) then
      with Inspector.PropertyList do
        if not Checked then PropValue[Tag] := ''
        else begin
          EventHandler := ValidPropValues[Tag];
          { Bei mehr als einer Ereignisbehandlungsroutine pro Typ
           ( EventHandler.Count > 1 ) wre eine Selektierung notwendig ! }
          if EventHandler.Count = 1 then PropValue[Tag] := EventHandler[0];
        end;
end;

{ Editieren der Eigenschaften }
procedure TForm1.UpdatePropValue(Control: TWinControl; AutoUpdate: Boolean);
var
  Buffer: array[Byte] of Char;
begin
  with Control do
    if Tag <> -1 then
      with Inspector.PropertyList do
        if not AutoUpdate or (paAutoUpdate in Attributes[Tag]) then
        begin
         { Holen des neuen Eigenschaftswertes }
          GetTextBuf(Buffer, 256);
          if CompareStr(StrPas(Buffer), PropValue[Tag]) <> 0 then

           try
             PropValue[Tag] := StrPas(Buffer);
           except
             on E: Exception do
             begin
               MessageDlg(E.Message, mtError, [mbOK], 0);
               { Anzeige aktualisieren }
               Inspector.RefreshDisplay;
               { Fehler beim Ereignis OnExit ?}
               if not Focused then SetFocus
               { Ansonsten alles selektieren }
               else
                 {$IFDEF WIN32}
                 SendMessage(Handle, EM_SETSEL, 0, -1);
                 {$ELSE}
                 SendMessage(Handle, EM_SETSEL, 1, $FFFF0000);
                {$ENDIF}
             end;

           end;
        end;
end;

procedure TForm1.GetSelPropIndex(Sender: TObject; var SelIndex: Integer);
begin
  if ActiveControl <> nil then SelIndex := ActiveControl.Tag;
end;

{ Aktuelle Eigenschaftswerte anzeigen }
procedure TForm1.ShowPropValue(Sender: TObject);
var
  Control: TWinControl;
  I: Integer;
begin
  for I := 0 to ControlCount - 1 do
    if Controls[I] is TWinControl then
    begin
      Control := TWinControl(Controls[I]);
      if Control.Tag <> -1 then
        with Inspector.PropertyList do
        begin
          if Control is TCheckBox then
            TCheckBox(Control).Checked := PropValue[Control.Tag] <> ''
          else if Control is TMultiComboBox then
            TMultiComboBox(Control).Text := PropValue[Control.Tag]
          else if Control is TEdit then
             TEdit(Control).Text := PropValue[Control.Tag];
        end;
    end;
end;

{ Initialisieren der einzelnen Kontrolelemente, mit denen die Eigenschaften
  des ColorStringGrids gendert werden knnen. Der Name der Eigenschaft fr das
  das Kontrolelement zu stndig ist, wurde zur Entwurfszeit der Eigenschaft Text
  zugewiesen.}
procedure TForm1.InspectorChanged(Sender: TObject);
var
  Buffer: array[0..255] of Char;
  Control: TControl;
  Properties: TStrings;
  I: Integer;
begin
  with Inspector do
    if State = isEndAddProp then
    begin
      Properties := PropertyList.PropNames;
      for I := 0 to ControlCount -1  do
      begin
        Control := Controls[I];

        with Control do
          if (ClassType = TCheckBox) or (ClassType = TEdit) or
            (ClassType = TMultiComboBox) then
          begin
            { Holen des Eigenschaftsnamens }
            GetTextBuf(Buffer, 256);
            { Speichern des Index in der Eigenschaft Tag }
            Tag := Properties.IndexOf(StrPas(Buffer));
            { Fehlerprfung }
            if Tag = -1 then MessageDlg(FmtLoadStr(SColSGrDemoPropError,
              [StrPas(Buffer), Control.Name]), mtError, [mbOk], 0)
            { Fllen der ComboBoxen }
            else if (ClassType = TMultiComboBox) then
              TMultiComboBox(Control).Items := PropertyList.ValidPropValues[Tag];
          end
          else Tag := -1;

      end;
      RefreshDisplay;
    end;
end;

{ TDemoPropertyInspector }
function TDemoPropertyInspector.GetSelProperty: Integer;
begin
  Result := -1;
  if Assigned(FOnGetSelProperty) then FOnGetSelProperty(self, Result);
end;

procedure TDemoPropertyInspector.UpdateDisplayValues;
begin
  if Assigned(FOnUpdateDisplayValue) then FOnUpdateDisplayValue(self);
end;

procedure TDemoPropertyInspector.RefreshDisplay;
begin
  if Complete then UpdateDisplayValues;
end;

end.



