{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit ObInMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, PrpCtrls, PropInfo, RtAddReg, RtReg,
  RtStdReg;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    RtObjectInspector1: TRtObjectInspector;
    RegStdPropertyEditors1: TRegStdPropertyEditors;
    RegAddPropertyEditors1: TRegAddPropertyEditors;
    procedure FormCreate(Sender: TObject);
    procedure RtObjectInspector1Change(Sender: TObject);
    procedure RtObjectInspector1CanFormChange(Sender: TObject;
      NewForm: TForm; var CanChange: Boolean);
    procedure FormDestroy(Sender: TObject);
  private
  protected
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
  public
    { Public-Deklarationen }
    procedure RestoreInspector;
  end;

var
  Form1: TForm1;
  Inspector: TRTObjectInspector;

implementation

{$R *.DFM}

uses ObInProp, ScreenCt, EventDum, DemoHelp;

{ Keine Dialogfenster akzeptieren }
procedure TForm1.RtObjectInspector1CanFormChange(Sender: TObject;
  NewForm: TForm; var CanChange: Boolean);
begin
  CanChange := (NewForm = nil) or (NewForm.BorderStyle <> bsDialog)
end;

{ Da Ereignisbehandlungsroutinen ber den RtObjectInspector jeder Komponente
  zugewiesen werden knnen, erfolgt in den folgenden jeweils eine berprfung. }
procedure TForm1.RtObjectInspector1Change(Sender: TObject);
begin
  if (Sender = Inspector) and (Form2 <> nil) then Form2.InspectorChanged;
end;

procedure TForm1.FormCreate(Sender: TObject);
const
  First: Boolean = True;
begin
  if First then
  begin
    InitHelp;
    with Inspector.BoundsRect do BoundsRect := Rect(Right, 0, Right +
      (Screen.Width - Right), Height);
    EventDummy.SetEvents(self);
    First := False;
    with Memo1 do
    begin
      { sonst bleibt kein Platz fr neue Komponenten }
      Align := alNone;
      WordWrap := True;
    end;
  end;
end;

procedure TForm1.RestoreInspector;
var
  R: TRect;
begin
  if Inspector = nil then
  begin
    RTObjectInspector1 := TRTObjectInspector.Create(self);
    with RTObjectInspector1 do
    begin
      OnChange := RTObjectInspector1Change;
      OnCanFormChange := RTObjectInspector1CanFormChange;
      StayOnTop := True;
      R := Form2.BoundsRect;
      with R do
      begin
        if Screen.Width - Right < Width then Left := Left - Width
        else Left := Right;
        Right := Left + Width;
        BoundsRect := R;
      end;
    end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if csDestroying in ComponentState then FreeHelp;
end;

procedure TForm1.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  if AComponent is TRTObjectInspector then
    if (Operation = opRemove) then Inspector := nil
    else Inspector := TRTObjectInspector(AComponent);
  inherited Notification(AComponent, Operation);
end;

end.

